;--------------------------------------------------------
;	Basic Window for Applications			;
;	Roger Stone  3-10-2008				;
;--------------------------------------------------------
#include \goasm\include\gowindows.inc
#include \goasm\include\all_api.inc
#include \goasm\include\kernel32.inc

;----------------------------------------------------------------
.data

WM_HAVE_FOCUS	equ WM_USER+100

BLUE		equ 0B00000h
GREEN		equ 0008000h
MAGENTA		equ 0A000B0h

ClassName 	db "WindClass",0
AppName  	db "Application Base",0
EditClass 	db "EDIT",0

AppMessg1	db 0Dh,0Ah,0Dh,0Ah,0Dh,0Ah,0Dh,0Ah,0Dh,0Ah,0Dh,0Ah,0Dh,0Ah
		;db 0Dh,0Ah,0Dh,0Ah,0Dh,0Ah,0Dh,0Ah
		db "     Framework for Application",0Dh,0Ah,0Dh,0Ah
		db "                Version 2",0Dh,0Ah,0Dh,0Ah
		db "          Type something!", 0Dh,0Ah,0Dh,0Ah,0
AppMessg2	db	' You typed ',0
AppMessg3	db	' characters', "  ",0Dh,0Ah,0
AppMessg4	db	'10 or more', "  ",0


Prompt		DB " ok:> " ,0


TestStg1        db " 1 Test string 1 ",0
TestStg2        db " 2 Test string 2 ",0

FontTest1	db " M.M.M.M.M.M ",0
FontTest2	db " W.W.W.W.W.W ",0
FontTest3	db " D.D.D.D.D.D ",0
Caption         db  'Message', 0


ALIGN 4
hInstance	DD 0
hWndEditTop	dd 0
hWndEditBot	dd 0
ThreadID	DD 0
hTextFlag	DD 0

hwnd		DD 0

OldWndProcTop	dd 0
OldWndProcBot	dd 0

ScnColor	dd GREEN
Chout		dd 0000020h		; char to output with extra zeros
KeyBdBuff	db 80h dup (0) 		; Buffer for keyboard use
TextBuffNextPtr	dd 0			; Pointer to next char in Text Buffer
TextBuffEndPtr	dd 0			; Pointer to end of Text Buffer
TextBuff	db 80h dup (0) 		; Text input buffer for APPLICATION

 
.code
;----------------------------------------------------------------
start:
	invoke GetModuleHandle, NULL
	mov    [hInstance],eax
	invoke WinMain, [hInstance],NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax
;----------------------------------------------------------------

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW or CS_VREDRAW
	mov D[wc.lpfnWndProc], OFFSET WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInst]
	pop [wc.hInstance]
	mov D[wc.hbrBackground], COLOR_ACTIVEBORDER+1	
	mov D[wc.lpszMenuName],NULL
	mov D[wc.lpszClassName],OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPED+WS_VISIBLE+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX+WS_MAXIMIZEBOX,\
           CW_USEDEFAULT,CW_USEDEFAULT,600,410,NULL,NULL,[hInst],NULL
	mov [hwnd],eax

	invoke SendMessage, [hWndEditTop], EM_SETMARGINS, EC_LEFTMARGIN+EC_RIGHTMARGIN, 00C000Ch
	invoke SendMessage, [hWndEditBot], EM_SETMARGINS, EC_LEFTMARGIN+EC_RIGHTMARGIN, 00C000Ch

			;Retrieve a message from the thread message queue
x1:             invoke GetMessage, ADDR msg,NULL,0,0
		cmp eax,-1
		jz >x2				;exit if error 
		test eax,eax			;EAX=0 if WM_QUIT
		jz >x2
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
		jmp x1
x2:		mov eax,[msg.wParam]
	ret
WinMain endf
;----------------------------------------------------------------
WndProc FRAME hWnd, uMsg, wParam, lParam

      LOCAL hdc

	mov eax,[uMsg]
	;---------------------
	cmp eax,WM_CREATE
	jnz >>w1

	;--------<  Make Bottom display Window and subclass it  >-------

		invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,NULL,\			;WS_EX_CLIENTEDGE
     	           WS_CHILD+WS_VISIBLE+ES_MULTILINE+ES_AUTOVSCROLL,\	;+WS_BORDER,\ES_AUTOHSCROLL+
        	   21,342,548,20,[hWnd],NULL,[hInstance],NULL
		mov [hWndEditBot],eax
		invoke SetFocus,eax
			; Make it a Subclass
		invoke SetWindowLong,[hWndEditBot],GWL_WNDPROC,addr EditWndProcBot
		mov [OldWndProcBot],eax

	;-----------<  Make Top display Window and subclass it  >--------

		invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,NULL,\
     	           WS_CHILD+WS_VISIBLE+WS_BORDER+ES_MULTILINE+ES_AUTOVSCROLL,\	;+WS_BORDER,\+ES_AUTOHSCROLL
  	           20,20,550,342,[hWnd],NULL,[hInstance],NULL
		mov [hWndEditTop],eax
			; Make it a Subclass
		invoke SetWindowLong,[hWndEditTop],GWL_WNDPROC,addr EditWndProcTop
		mov [OldWndProcTop],eax

			; Change font to fixed width
		invoke GetDC,[hWndEditTop]
		mov [hdc],eax
		invoke GetStockObject, OEM_FIXED_FONT
		invoke SelectObject, [hdc], eax
		invoke [SendMessage], [hWndEditTop], EM_REPLACESEL, 0, offset FontTest1 

	;--------------------<  Start App thread  >----------------------

		mov  eax,OFFSET ThreadProc
		invoke CreateThread, NULL, NULL, OFFSET ThreadProc, NULL,\
		     NORMAL_PRIORITY_CLASS, ADDR ThreadID
		invoke CloseHandle,eax			; will not need handle
			; Create event object to communicate with thread
		invoke CreateEvent,NULL,TRUE,FALSE,NULL
		mov [hTextFlag],eax
		jmp >w4
	;---------------------
w1:	cmp eax,WM_DESTROY
	jnz >w2
		invoke PostQuitMessage,NULL
		jmp >w4
	;---------------------
w2:		cmp eax,WM_CTLCOLOREDIT
		jnz >w3
		invoke SetTextColor,[wParam],[ScnColor]	; sets colours of window
		invoke SetBkColor,[wParam], White	;0F0F8FFh
		invoke GetStockObject,WHITE_BRUSH	;WHITE_BRUSH
		ret					; returns handle of brush
		;----------
w3:		invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]		
		ret
	;---------------------
w4:	xor eax,eax
	ret
WndProc endf
;----------------------------------------------------------------
EditWndProcTop FRAME hEdit,uMsg,wParam,lParam

        LOCAL hdc
        LOCAL hdcTop

        LOCAL ps:PAINTSTRUCT
        LOCAL rect:RECT
	LOCAL hfont

	mov eax,[uMsg]
	;---------------------
	cmp eax,WM_CREATE
	jnz >e1
			; Change font to fixed width
		invoke GetDC,[hWndEditTop]
		mov [hdc],eax
		invoke GetStockObject, OEM_FIXED_FONT
		invoke SelectObject, [hdc], eax
		invoke [SendMessage], [hWndEditTop], EM_REPLACESEL, 0, offset FontTest2 
	jmp >>e3
	;---------------------
e1:	cmp eax,WM_PAINT
	jnz >>e2  
		invoke BeginPaint,[hEdit], ADDR ps
		mov [hdc],eax
			; Change font to fixed width
		invoke GetStockObject, OEM_FIXED_FONT
		invoke SelectObject, [hdc], eax
		mov [hfont],eax

		invoke GetClientRect,[hEdit], ADDR rect
			; Some text to see what happens
		invoke TextOut,[hdc],50,48,ADDR FontTest3, SIZEOF FontTest3 
		invoke SetBkColor,[hdc],0FFFFh 
		invoke DrawText, [hdc],ADDR TestStg1,SIZEOF TestStg1, ADDR rect, DT_EDITCONTROL+DT_WORDBREAK
		invoke SetBkColor,[hdc],0E080FFh ;0ffFFh 
		invoke TextOut,[hdc],300,50,ADDR TestStg2,SIZEOF TestStg2
		invoke SetBkColor,[hdc],0E8F4FFh 

;		invoke SelectObject, [hdc], [hfont]
		invoke EndPaint,[hEdit], ADDR ps

		invoke SetFocus,[hWndEditBot]			; don't want focus, send it to bottom window
		jmp >e3						; must let OS paint edit boxes
	;---------------------
e2:	cmp eax,WM_SETFOCUS
	jnz >e3   
		invoke SetFocus,[hWndEditBot]			; don't want focus, send it to bottom window
		jmp >e4
	;---------------------
e3:		invoke CallWindowProc,[OldWndProcTop],[hEdit],[uMsg],[wParam],[lParam]
		ret
	;---------------------
e4:	xor eax,eax
	ret
endf
;----------------------------------------------------------------
EditWndProcBot FRAME hEdit,uMsg,wParam,lParam

	mov eax,[uMsg]
	;---------------------
	cmp eax,WM_CHAR
	jnz >b1
			; restore color
		mov eax,GREEN
		mov [ScnColor],eax

		mov eax,[wParam]				; wParam is key character
		cmp al,VK_RETURN
		jz >> b2					; dont want ret in buffer but must let old proc have it
		cmp al,VK_BACK
		jnz >c1
		dec B[KeyBdBuff]				; do the backspace here, 
		jmp >c2						; no need for it to go into buffer
		;-----
			; put chars into buffer
c1:		movzx ecx, B[KeyBdBuff]				; Get count from start of buffer
        	inc ecx
        	mov [KeyBdBuff],cl				; save it
        	add ecx, offset KeyBdBuff			; point to end
        	mov [ecx],eax					; move character
c2:			; change color of some characters ( before q )
		cmp eax,70h
		jnc >>b2
		mov eax,MAGENTA
		mov [ScnColor],eax

		jmp >>b2				; now send chars for proccessing by original procedure
	;---------------------
b1:	cmp eax,WM_KEYDOWN
	jnz >b2
	    mov eax,[wParam]
	    cmp al,VK_RETURN				; Only do when return key
	    jnz >b2					; send rest to original procedure

	;---------------< copy to thread buffer >------------------------

		push edi
		push esi
		mov esi, addr KeyBdBuff
		mov edi, addr TextBuff			; First byte is count
		movzx ecx, B[KeyBdBuff]
		inc esi					; don't include count byte
		rep movsb
		mov B[edi],20h				; space to mark end of last word
		mov [TextBuffEndPtr],edi
		mov eax,0
		mov edi,eax				; add zeros to end
		pop esi
		pop edi

	;---------------< Send to display window >------------------------

	        movzx ecx,B [KeyBdBuff]			; Get count from start of buffer
	        inc ecx					; point 
	        add ecx, offset KeyBdBuff		; point to end
		mov eax,000A0Dh				; CR,LF and zero string terminator
		mov [ecx],eax				; add to end of string
	        sub ah,ah
	        mov [KeyBdBuff],ah				; reset count for next time
		invoke [SendMessage], [hWndEditTop], \
			EM_REPLACESEL, 0, offset KeyBdBuff+1	; send to top window
		invoke SetEvent,[hTextFlag]			; Tell thread its there
	xor eax,eax						; don't need original proccedure
	ret
	;---------------------
b2:	invoke CallWindowProc,[OldWndProcBot],[hEdit],[uMsg],[wParam],[lParam]
	ret
endf
;----------------------------------------------------------------

ThreadProc FRAME lParam	; Parse Text from keboard

		;------------< Startup Message >------------

	invoke [SendMessage], [hWndEditTop], EM_REPLACESEL, 0, offset AppMessg1	; Header

		;-------< Prompt and wait for input >-------

T1:	invoke [SendMessage], [hWndEditBot], EM_REPLACESEL, 0, offset Prompt
	invoke WaitForSingleObject,[hTextFlag],INFINITE	

		;------< Aplication code can go here >------
			; must do something that can be seen

	invoke [SendMessage], [hWndEditTop], EM_REPLACESEL, 0, offset AppMessg2 ; You typed
	mov eax,BLUE					; reset color
	mov [ScnColor],eax	
	mov eax, [TextBuffEndPtr]
	sub eax, offset TextBuff			; calculate no chars sent
	cmp eax, 10					; can't count over 9
	jnc >t2						; jump if to many
	add eax, 30h
	mov [Chout], eax	
	invoke [SendMessage], [hWndEditTop], EM_REPLACESEL, 0, offset Chout 
	jmp > t3
	;-------
t2:	mov eax,MAGENTA					; change color when to many
	mov [ScnColor],eax
	invoke [SendMessage], [hWndEditTop], EM_REPLACESEL, 0, offset AppMessg4 ; 10 or more
t3:	invoke [SendMessage], [hWndEditTop], EM_REPLACESEL, 0, offset AppMessg3 ; chars
	mov  d[TextBuffEndPtr],0

		;-----< reset semaphore for next input >-----
	invoke ResetEvent, [hTextFlag]	
 	jmp <<T1

;----------------------------------------------------------------
	ret
endf
